/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

  /* header file for accessing built-in attributes (C++ version) */

#ifndef att_h
#define att_h

#include <InterViews/brush.h>
#include <InterViews/color.h>

class Brush;
class Color;

  /* shape types, brush types, color types */
enum NShape {rectangle, circle, diamond, oval, npoint, double_box, line};
enum BType {solidb, bsolidb, dottedb, bdottedb, dashedb, bdashedb};
enum CType {blackc, grayc, whitec};

enum AttType {shapet, brusht, colort};

static const numshape = 7;
static const numbrush = 6;
static const numcolor = 3;

static const default_shape = rectangle;
static const default_brush = solidb;
static const default_color = blackc;

extern Brush* brushes[numbrush];
extern Color* palette[numcolor];

  /* get the next/prev shape/color/brush.  Uses wraparound */
NShape NextShape(NShape);
CType NextColor(CType);
BType NextBrush(BType);
NShape PrevShape(NShape);
CType PrevColor(CType);
BType PrevBrush(BType);

static const db_margin = 3;	/* margin between inner and outer boxes for a 
				   double box */

#endif
