/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

/* View of the buttons */

#ifndef bview_h
#define bview_h

#include <InterViews/interactor.h>
#include <InterViews/button.h>
#include <InterViews/box.h>
#include <InterViews/menu.h>

class Button;
class PushButton;
class CheckBox;
class MyMenu;
class TextItem;
class GraphFrame;

// buttons with menus

class MenuButton : public PushButton 
{
    friend class ButtonView;
public:
    void Handle(Event&);
    MenuButton(char*, ButtonState*, MyMenu*, void (*)(TextItem*));
    void ChangeMenu(MyMenu*);
    void SetFrame(GraphFrame*);
private:
    MyMenu* menu;			// the menu
    void (* pressf) (TextItem*);	// what to do when pressed
    ButtonState* bstate;
    GraphFrame* frame;			// the frame around us
};


// buttons to indicate the current mode

class FlipButton : public CheckBox 
{
public:
    FlipButton(char*, ButtonState*, int, int, void (*)());
    void Press();
    void SetOpp (FlipButton*, FlipButton*);	
    void SetFrame(GraphFrame*);
    void unpress();
private:
    void (* pressf) ();		// what to do when activated
    int offval, onval;
    FlipButton* opp1;		// the other two flipbuttons
    FlipButton* opp2;
    GraphFrame* frame;		// the frame around us
};

static const numopts = 11;	// number of items in the options menu

class ButtonView : public HBox 
{
public:
    ButtonView();
    void NewOptionsMenu(char[]);
    void SetFrame (GraphFrame*);
private:
    ButtonState* bmbstate;
    ButtonState* cmbstate;
    ButtonState* embstate;
    MenuButton* commandButton;
    MenuButton* editButton;
    MenuButton* optionsButton;
    MenuButton* fileButton;
    FlipButton* browseMButton;
    FlipButton* changeMButton;
    FlipButton* editMButton;
    TextItem* tti[numopts];
		/* Changable menu selections for the (changable) options */
};

#endif
