/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

// The frame surrounding the grab window.  Apart from the graph
// attributes window, the top-level interactor

#ifndef gframe_h
#define gframe_h

#include <InterViews/scene.h>
#include <InterViews/graphic.h>
#include "att.h"
#include "graph.h"
#include "curs.h"
#include "mypanner.h"

class ButtonState;
class Dialog;
class Menu;
class Viewport;
class GView;
class ButtonView;
class TextView;
class DrawView;
class GrabWindow;
class MyPanner;
class Font;
class FontHandler;
class VBox;
class HBox;

class GraphFrame : public MonoScene 
{
public:
    GraphFrame(GView*, TextView*);
    void SetCurs(Curs);
    void UnsetCurs();			// go back to the default cursor
      // interface to the textview
    void ChangeStatusLine(char*, boolean now = false);
    void ChangeGraphName(char*);
    void ChangeFileName(char*);
      // interface to the button view
    void ChangeToggles(char[]);		// change the options menu
      // interface to the fonthandler
    void InitFonts();
    void SetFont(int, int);
    boolean TextFits();			
    void ForceNL();
    void NoForceNL();
    void ForceEL();
    void NoForceEL();
    void SmallestFont(int*, int*);
    void SetPS(char*);
    int WidthPS(char*);
      // interface to the panner
    void ChangeZGrad(float);
    Interactor* GetSide() { return panner->slider; };
      // interface to the built-in attributes display
    boolean ShapeSet();
    boolean BrushSet();
    boolean ColorSet();
    NShape CurShape();
    BType CurBrush();
    CType CurColor();
    void drawside();
    HBox* GetNoframe() { return noframe; } ;
private:
    HBox* noframe;		// the side window and the graph view
    GrabWindow* gwin;		
    MyPanner* panner;
    DrawView* dview;
    VBox* sidewin;
    Curs currentCursor;
    FontHandler* fhandler;

    void Init();
    void InitCursors();
    void MakeFrame();
};

#endif
