/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1987, 1988, 1989 Stanford University
   Copyright (c) 1989, Tera Computer Company
 **/

#ifndef helper_h
#define helper_h

#include <InterViews/scene.h>

// Declare imported types.

class ButtonState;
class IMessage;
class StringList;
class Graphic;
class TextEdit;

// A TextBox knows how to set its message and how
// to pop up itself over the underlying Interactor.

class TextBox : public MonoScene 
{
public:
    void SetUnderlying(Interactor*);
protected:
    TextBox(Interactor*, StringList* s, Graphic*);
    ~TextBox();
    void PopUp();
    void Disappear();

    TextEdit* tedit;		// displays text
    Interactor* underlying;	// we'll insert ourselves into its parent
};

// A Pager displays a page of text

class Pager : public TextBox 
{
public:
    Pager(Interactor*, StringList* s, Graphic*);
    char Display();
protected:
    void Reconfig();
};

static const maxhelppage = 6;
static const maxline = 80;

class Helper 
{
public:
    Helper(Interactor*, Graphic*);
    void DoHelp();
private:
    Pager* helppagers[maxhelppage];
    int currpage;
    Pager* MakePager(int, Interactor*, Graphic*);
};

#endif
