/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1987, 1988, 1989 Stanford University
   Copyright (c) 1989, Tera Computer Company
 **/

/*
 * My Adjuster - button-like interactors for incremental adjustment of an
 * interactor's perspective.
 * Just like the adjuster class in InterViews 2.5, except the zoom gradient
 * can be set.
 */

#ifndef myadjuster_h
#define myadjuster_h

#include <InterViews/adjuster.h>
#include <InterViews/interactor.h>

class Bitmap;
class Shape;

class MyZoomer : public Adjuster {
public:
    MyZoomer(Interactor*, float factor);
    MyZoomer(const char*, Interactor*, float factor);
    MyZoomer(Interactor*, float factor, Painter*);
protected:
    float factor;
    void AdjustView(Event&);
private:
    void Init(float);
};

class MyEnlarger : public MyZoomer {
public:
    MyEnlarger(Interactor*, float zg = 2.0);
    MyEnlarger(const char*, Interactor*, float zg = 2.0);
    MyEnlarger(Interactor*, Painter*, float zg = 2.0);
    void ChangeZGrad(float);
private:
    void Init();
};

class MyReducer : public MyZoomer {
public:
    MyReducer(Interactor*, float zg = 0.5);
    MyReducer(const char*, Interactor*, float zg = 0.5);
    MyReducer(Interactor*, Painter*, float zg = 0.5);
    void ChangeZGrad(float);
private:
    void Init();
};

#endif
