/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1987, 1988, 1989 Stanford University
   Copyright (c) 1989, Tera Computer Company
 **/

/*
 * MyPanner - an interactor for two-dimensional scrolling and zooming.
 * Just like panner in InterViews 2.5, except it uses MyAdjuster instead of
 * Adjuster 
 */

#ifndef mypanner_h
#define mypanner_h

#include <InterViews/scene.h>

class MyEnlarger;
class MyReducer;

class MyPanner : public MonoScene 
{
public:
    MyPanner(Interactor*, int size = 0);
    MyPanner(const char*, Interactor*, int size = 0);
    MyPanner(Interactor*, int size, Painter*);
    void ChangeZGrad(float);

    Interactor* slider;
protected:
    int size;

    virtual void Reconfig();
private:
    Interactor* adjusters;
    MyReducer* reducer;
    MyEnlarger* enlarger;

    void Init(Interactor*, int);
};

#endif
