/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

// The inverse of interf.c -- C++ interface for C routines

#ifndef routines_h
#define routines_h

// Routines to get the C routines to do something (after selecting a
// menu item or pressing a button, say)

extern "C"
{
extern void DoShowBC(), DoDebugMode(), DoRedisplay(), DoLayoutGraph();
extern void DoChangeFileName(), DoReadFile(), DoWriteFile();
extern void DoCreatePSFile(), DoPSScreen();
extern void DoSetZoomGrad(), DoSetPanGrad(), DoSizeToFit();
extern void DoChangeText(), DoChangeEdgeLabel(), DoBrowseMode();
extern void DoChangeMode();
extern void DoEditMode(), DoRedrawGraph(), DoPrintLabel();
extern void DoSetEdge(), DoResetEdge(), DoSetNode(), DoResetNode();
extern void DoSetEdges(), DoResetEdges();
extern void DoCycleEdge(), DoCycleNode();
extern void DoChangeOutEdges(), DoChangeInEdges();
extern void DoMarkDummyNodes(), DoDrawArrow(), DoFullScrolling();
extern void DoRotatePSFile(), DoPrintEdgeLabel(), DoShowLevels();
extern void DoHelp(), DoQuit(), DoPrintLayoutStats(), DoPrintUsage();
extern void DoShowSize(), DoDumpNodeList(), DoStraighten();
extern void NewFont();
extern void ClearInModeFlag();
extern void DoSetUpMove(), DoMoveEnd();
extern void DoResetCursor();
extern void DoChangeNodeText(), DoChangeEdgeText(), DoSInsertNode();
extern void DoFocusCurNode(), DoFocusNode();
extern void DoFocusNamedNode();
extern void DoSDeleteNode(), DoSDeleteArc();
extern void DoGraph(), DoSetDisplayed();
extern void DoShowEAttr(), DoShowNAttr(), DoEraseAttrBox();
extern void DoNextCkpt(), DoSaveCkpt(), DoPrevCkpt();
extern void DoGetCommandsFromFile(), DoIgnoreHidden();

// Information-gatherers

extern void GetSBounds(int*, int*, int*, int*);
extern boolean GetBCFlag(), GetBModeFlag(), GetPAFlag();
extern boolean GetCModeFlag(), GetEModeFlag();
extern double GetHeight();
extern boolean GetInCModeFlag(), GetMarkDummyFlag();
extern boolean GetInEFlag(), GetOutEFlag();
extern boolean Intersect(int, int, int, int, int, int, int, int);
extern boolean DoSetUpInsArc();
extern boolean DoInsArcEnd();
extern boolean GetInCTextModeFlag(), GetInCEdgeLabelModeFlag();
extern boolean GetInFNodeModeFlag();
extern double GetAspRatio();
};

#endif
