/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1986, 1988 Regents of the University of California
   Copyright (c) 1989, Tera Computer Company
 **/

/* screen.h -- a representation of the screen */

#ifndef screen_h
#define screen_h

typedef struct 			/* a rectangular area */
{			
    int min_x, min_y, max_x, max_y;
} BOX;

typedef struct 			/* the zoom factors */
{		
    float xzoom, yzoom;
} ZOOM;

typedef struct 			/* info for a screen */
{		
    BOX canvas;			/* size of abstract canvas */
    BOX display;		/* size of part of abstract canvas we see */
    ZOOM zoom;			/* current zoom factor */
    BOX absview;		/* absolute screen bounds (abstract canvas in 
					absolute coordinates) */
    BOX bound;			/* the display in absolute coordinates, 
					for bounds testing */
} SCREEN;

#endif
