/**
   GRAB Graph Layout and Browser System

   Copyright (c) 1989, Tera Computer Company
 **/

/* View of the text (status message, file name, graph name) */

#ifndef tview_h
#define tview_h

#include <InterViews/interactor.h>
#include <InterViews/box.h>
#include <InterViews/message.h>

static const gmax = 40;		/* length of the graph name */
static const fimax = gmax;	/* length of the file name */
static const smax = gmax * 2;	/* length of the status message */

// the graph and file names

class FirstLine : public HBox 
{
public:
    FirstLine(char*, char*);
    void ChangeFileName (char*);
    void ChangeGraphName (char*);
private:
    HBox* gbox;
    HBox* fbox;
    Message* gmsg;
    Message* fmsg;
    char *gname;
    char *fname;
};

// the status line

class SecondLine : public HBox 
{
public:
    SecondLine(char*);
    void ChangeStatus(char*);
private:
    HBox* sbox;
    Message* smsg;
    char *status;
};

// everyone together

class TextView : public VBox 
{
public:
    TextView(char*, char*);
    void ChangeStatusLine(char*, boolean);
    void ChangeFileName (char*);
    void ChangeGraphName (char*);
private:
    FirstLine* line1;
    SecondLine* line2;
    void Init();
};

#endif
